<?php

namespace app\common\model;

use think\Model;


class ReleaseArticleModel Extends Model
{
    // 表名
    protected $name = 'release_article';

    // 开启自动写入时间戳字段
    protected $autoWriteTimestamp = 'int';
    // 定义时间戳字段名
    protected $createTime = 'createtime';
    protected $updateTime = false;
    // 追加属性
    protected $append = [
    ];


    public static function queryReleaseArticle($where,$field="*",$page=1,$pageSize=10,$order='createtime desc'){
        $list= self::where($where)->field($field)->order($order)->limit($pageSize)->page($page)->select();
        foreach ($list as $key=>$val){
            $list[$key]['content']=mb_substr_content($val['content'],550);
        }
        return $list;
    }

    /**
     * 全部讨论区
     */
    public static function allReleaseArticle($where,$pageSize=10,$param){
        $list = self::where($where)->field('*,FROM_UNIXTIME(createtime,"%Y-%m-%d %h:%i:%s") as createtime_text')
            ->order('createtime desc')
            ->paginate($pageSize,false,['query' =>$param]);
        return $list;
    }


    /**
     * 等待回复
     */
    public static function awaitReleaseReply($where,$pageSize=10,$param){
        $list = self::alias("a")
            ->join("release_reply r","r.release_id= a.id","LEFT")
            ->where($where)->where("r.id IS NULL")->field('a.*,FROM_UNIXTIME(a.createtime,"%Y-%m-%d %h:%i:%s") as createtime_text')
            ->order('a.createtime desc')
            ->group("a.id")
            ->paginate($pageSize,false,['query' =>$param]);
        //echo  self::getLastSql();
        return $list;
    }


    /**
     * 教师回复留言
     */
    public static function teacherReleaseReply($where,$pageSize=10,$param){
        $list = self::alias("a")
            ->join("release_reply r","r.release_id= a.id","LEFT")
            ->join("admin ad","r.admin_id= ad.id","LEFT")
            ->where($where)->where("ad.type=2")->field('a.*,FROM_UNIXTIME(a.createtime,"%Y-%m-%d %h:%i:%s") as createtime_text')
            ->order('r.createtime desc')
            ->group("a.id")
            ->paginate($pageSize,false,['query' =>$param]);
        //echo  self::getLastSql();
        return $list;
    }

    /**
     * 我的回复留言
     */
    public static function myReleaseReply($where,$pageSize=10,$param){
        $list = self::alias("a")
            ->join("release_reply r","r.release_id= a.id","LEFT")
            ->where($where)->field('a.*,FROM_UNIXTIME(a.createtime,"%Y-%m-%d %h:%i:%s") as createtime_text')
            ->order('a.createtime desc')
            ->group("a.id")
            ->paginate($pageSize,false,['query' =>$param]);
        //echo  self::getLastSql();
        return $list;
    }


    /**
     * 我的回复留言
     */
    public static function myReleaseArticle($where,$pageSize=10,$param){
        $list = self::where($where)->field('*,FROM_UNIXTIME(createtime,"%Y-%m-%d %h:%i:%s") as createtime_text')
            ->order('createtime desc')
            ->paginate($pageSize,false,['query' =>$param]);
        return $list;
    }
}
