<?php


namespace app\index\controller;


use app\common\controller\Backend;
use app\common\controller\Frontend;
use app\common\model\AdModel;
use app\common\model\CourseArticleModel;
use app\common\model\CourseClassModel;
use app\common\model\ReleaseArticleModel;
use app\common\model\ReleaseReplyModel;
use think\Db;
use think\Hook;
use think\Session;

/**互动平台
 * Class Interactive
 */
class Interactive extends Backend
{
    protected $noNeedLogin = '*';
    protected $noNeedRight = '*';
    protected $layout = '';
    protected $pagesize = 10;


    public function index(){
        $AdList=AdModel::getAdList(11,1);
        $class_ids=CourseClassModel::ClassField(" id in (100,101)","id,title,image_url,pid,index_type","select");
        $child_class_ids_one=CourseClassModel::ClassField(" id !=100 and FIND_IN_SET(100,pidexist)","id,title,image_url,pid,index_type","select");
        $child_class_ids_two=CourseClassModel::ClassField(" id !=101 and FIND_IN_SET(101,pidexist)","id,title,image_url,pid,index_type","select");
        foreach ($child_class_ids_one as $k=>$v){
            $pageSize=12;
            $child_class_ids_one[$k]['ChildArticle']=CourseArticleModel::queryArticle(['class_id'=>$v['id'],'status'=>0],"*,FROM_UNIXTIME(createtime,'%Y-%m-%d') as createtime_text",'1',$pageSize);
        }
        foreach ($child_class_ids_two as $k=>$v){
            $pageSize=4;
            $child_class_ids_two[$k]['ChildArticle']=CourseArticleModel::queryArticle(['class_id'=>$v['id'],'status'=>0],"*,FROM_UNIXTIME(createtime,'%Y-%m-%d') as createtime_text",'1',$pageSize);
        }

        $ZYAdList=AdModel::getAdList(21,1);
        $this->view->assign("AdList", $AdList);
        $this->view->assign("classIds", $class_ids);
        $this->view->assign("ZYAdList", $ZYAdList);
        $this->view->assign("child_class_ids_one", $child_class_ids_one);
        $this->view->assign("child_class_ids_two", $child_class_ids_two);
        return $this->view->fetch("index/hdptindex");
    }


    /**互动讨论区
     */
    public function interactdiscuss()
    {
        $datatype=$this->request->param("datatype",1);
        $keywords=$this->request->param("keywords");
        $where['is_delete']=0;$where2['a.is_delete']=$where3['a.is_delete']=$where4['a.is_delete']=$where5['is_delete']=0;
        if(!empty($keywords)){
            $where['content'] = ['like',"%$keywords%"];
            $where2['a.content']=$where3['a.content']=$where4['a.content']=$where5['content']=['like',"%$keywords%"];
        }
        if(in_array($datatype,[2,3,4,5]) && $this->auth){
            $where2['a.admin_id']=$where4['r.admin_id']=$where5['admin_id']=$this->auth->id;
            if ($datatype==2){
                $list = ReleaseArticleModel::awaitReleaseReply($where2,$this->pagesize,$this->request->param());
            }else if ($datatype==3){
                $list = ReleaseArticleModel::teacherReleaseReply($where3,$this->pagesize,$this->request->param());
            }else if ($datatype==4){
                $list = ReleaseArticleModel::myReleaseReply($where4,$this->pagesize,$this->request->param());
            }else{
                $list = ReleaseArticleModel::myReleaseArticle($where5,$this->pagesize,$this->request->param());
            }
        }else {
            $list = ReleaseArticleModel::allReleaseArticle($where,$this->pagesize,$this->request->param());
        }
        foreach ($list as $key=>$val){
            $list[$key]['content']=mb_substr_content($val['content'],550);
            $list[$key]['adminuser']=Db::name("admin")->where(['id'=>$val['admin_id']])->field("username,nickname,avatar,type")->find();
            $list[$key]['countTeacherReply']=ReleaseReplyModel::alias("r")
                ->join("admin a","r.admin_id= a.id","LEFT")
                ->where(['r.is_delete'=>0,'r.release_id'=>$val['id'],'a.type'=>2])->count();
            $list[$key]['countStudentReply']=ReleaseReplyModel::alias("r")
                ->join("admin a","r.admin_id= a.id","LEFT")
                ->where(['r.is_delete'=>0,'r.release_id'=>$val['id'],'a.type'=>1])->count();
            $list[$key]['countAllReply']=ReleaseReplyModel::where(['is_delete'=>0,'release_id'=>$val['id']])->count();
        }

        $this->view->assign("list", $list);
        $page = $list->render();
        $total=$list->total();
        $this->view->assign("total", $total);
        $this->view->assign("page", $page);
        $this->view->assign("offset", ($list->currentPage() - 1) * $list->listRows() + 1);
        $currenttotal= $list->currentPage() * $list->listRows();
        if ($currenttotal> $list->total()) {
            $currenttotal =  $list->total();
        }
        $this->view->assign("currenttotal", $currenttotal);
        $this->view->assign("keywords", $keywords);
        $this->view->assign("datatype", $datatype);
        return $this->view->fetch("index/interactdiscuss");
    }
     /*
      * 添加留言板
      */
    public function ajaxAddReleaseArticle(){
        $content=$this->request->param("content");
        if(empty($content)){
            $this->error("请输入留言内容！");
        }
        if ($this->auth->isLogin()) {
            ReleaseArticleModel::create(['admin_id'=>$this->auth->id,'content'=>$content,'createtime'=>time()]);
            $this->success("留言成功！");
        }else {
            $this->error(__('Please login first'), url('index/login'));
        }
    }

    /**
     * 添加留言评论
     */
    public function ajaxAddReleaseReply(){
        $content=$this->request->param("content");
        $release_id=$this->request->param("release_id");
        if(empty($content)){
            $this->error("请输入留言内容！");
        }
        if(empty($release_id)){
            $this->error("请选择留言内容进行评论！");
        }
        if ($this->auth->isLogin()) {
            ReleaseReplyModel::create(['release_id'=>$release_id,'admin_id'=>$this->auth->id,'content'=>$content,'createtime'=>time()]);
            $this->success("留言成功！");
        }else {
            $this->error(__('Please login first'), url('index/login'));
        }
    }

    /**
     * 分页加载评论列表
     */
    public function loadingReleaseReply(){
        $release_id=$this->request->param("release_id");
        $page=$this->request->param("page",1);
        $type=$this->request->param("type",0);//教师2，学生1 全部0
        $map['r.is_delete']=0;
        $map['r.release_id']=$release_id;
        if(in_array($type,[1,2])){
            $map['a.type']=$type;
        }
        $list=ReleaseReplyModel::alias("r")
            ->join("admin a","r.admin_id= a.id","LEFT")
            ->where($map)
            ->field('r.*,FROM_UNIXTIME(r.createtime,"%Y-%m-%d %h:%i:%s") as createtime_text,a.username,a.nickname,a.avatar,a.type')
            ->order('r.createtime desc')
            ->limit($this->pagesize)
            ->page($page)
            ->select();

        /*$list =ReleaseReplyModel::where($where)->field('*,FROM_UNIXTIME(createtime,"%Y-%m-%d %h:%i:%s") as createtime_text')
            ->order('createtime desc')
            ->limit($this->pagesize)
            ->page($page)
            ->select();*/
        $list = collection($list)->toArray();
        $result = array("rows" => $list);
        return json($result);
    }




}